# Changelog

## v1.5.2.4

* Change usage of short array syntax to traditional array syntax in curl header request for PHP >= 5.3
* Clean up other syntax and docblocks in the file

## v1.5.2.3

* Fix Magento Connect Package Format

## v1.5.2.2

* Fix for PHP 5.3 and below where function calls were used as arrays. This notation is only supported in PHP 5.4 and above.

## v1.5.2.1

* Order Sync added

## v1.1.4.0

* Harvest resume command added

## v1.1.3.6

* Sample harvest

## v1.1.3.5

* Partial harvest fix
* Added cwd to shell callbacks

## v1.1.3.4

* Fix for subscriber collection init

## v1.1.3.3

* Nohup and nice managed by config

## v1.1.3.2

* Removed whitespace causing headers to get sent

## v1.1.3.1

* Fix for customer/subscriber id collisions

## v1.1.3

* Correctly assign parent sku to conversion report
* Added support for generic tracking params
* Partial harvest for store and type
* Harvest purchase statuses
* Mage 1.3 fix for resource declaration

## v1.1.2.3

* Clear config cache during store creation
* Broke harvest types out to callbacks

## v1.1.2.1

* Fixed issue with store registration

## v1.1.2.0

* Improved support for dynamic sku bundles in cart conversion
* Hardening purchase parser

## v1.1.1.2

* Added attributes to new format harvest
* Modified product landing url creation

## v1.1.1.1

* Show version number on admin page

## v1.1.1.0

* Added customer and product attribute set harvest
* Can set version stability for auto-updater e.g. beta
* Added listeners for attribute save
* Throttle listeners to minimize redundant api requests

## v1.1.0.2

* Refactor of harvester architecture
* Moved store creation to job
* Moved store creation to beginning of harvest

## v1.1.0.1

* Added remote updater

## v1.0.0.89

* Moved product action logging to after commit event
* Added debug level logging
* Added absolute path to `shell/springbot.php` calls
* Fixed bug which was resulting in empty harvest segments
* Check for directory separator when building image urls, insert if needed
* Smart parent sku finder for quotes and sales items

## v1.0.0.88

* Modified table definition for springbot_redirect_order
* Fixed runaway table bug for springbot_redirect_order
* Added shell_exec to list of system execution funtions
* Removed `getcwd` directory calls in the context of the app, replacing with `Mage::getBaseDir()`
* Added option to accept sb as redirect_mongo_id param on attributed clicks

## v1.0.0.87

* Added callback to configurable product save to post all child products
* User defined option to use cached image creation

## v1.0.0.86

* Fixed bug that was causing out of memory errors on purchase segments
* Corrected upcase inconsistencies with class names

## v1.0.0.85

* Redirect id backwards compatibility fix for version 1.5 and prior
* Added authentication check on admin page, shows login screen if user is not logged in
* Rewrote tests for compatibility with PHP 5.3
* Made halt command more robust
* Added segment size limit, able to set remotely on springbot/config/segment_size

## v1.0.0.84

* Allow order paid amount to fail over to `sales/order::base_grand_total` when payment not available
* Changed all financial details to utilize `base` fields
* Refactored listener purchase harvest to utilize parsers
* Added sanity check for mongoIds from cookie
* Refactored all NativeHarvester calls to use central api model
* Whitespace cleanup and abstraction of constants in observers
* Added engine/manager slim service class for full cli harvests
* Added Customer and Subscriber listeners
* Added username and password fields to config
* Fixed bug to use config security token in harvest authentication
* Redirect ids persist in database
* Extended sales_order listener to admin

## v1.0.0.83

* Fix cached payment bug on harvests

## v1.0.0.82

* Clear config cache on save in NativeEngine

## v1.0.0.81

* Refactored external logging into central static class
* Moved sync call to api model
* Improved harvest forecaster
* Added aggregate harvest counts across child processes
* Removed stdout echo logging
* Removed unused variables and files
* Added data source `[BH|OB]` to all posts
* Fixed `imageUrl` lookup to process `no_selection` properly
* Carts only post one time per unique collection of line items
* Added springbot configuration section
* Modified php_exec config param to allow for run-time options (e.g. set ini flags at run time)
* Fixed issue with unescaped redirect ids passed from cookie
