<?php

class Springbot_Main_Block_Adminhtml_Loginform extends Mage_Adminhtml_Block_Widget_Form
{

    /**
     * Create the form used to authenticate to Springbot
     */
    protected function _prepareForm()
    {
        $form = new Varien_Data_Form();
        $fieldset = $form->addFieldset('springbot_main_form', array(
            'legend' => Mage::helper('springbot_main')->__('Already Registered at www.springbot.com?')
        ));
        $fieldset->addField(
            'email', 'text', array(
                'label'    => Mage::helper('springbot_main')->__('Email'),
                'class'    => 'required-entry',
                'required' => true,
                'name'     => 'email'
            )
        );
        $fieldset->addField(
            'password', 'password', array(
                'label'    => Mage::helper('springbot_main')->__('Password'),
                'class'    => 'required-entry',
                'required' => true,
                'name'     => 'password',
            )
        );

        $fieldset->addField(
            'link', 'note', array(
                'label' => '',
                'text'  => '<a href="https://app.springbot.com/content/get_registered" target="_blank">Need a Springbot Account? Click Here</a>',
            )
        );

        // Hide submit button so that we can press enter to submit
        $fieldset->addElement(new Varien_Data_Form_Element_Submit(array(
            'style' => 'position: absolute; left: -9999px; width: 1px; height: 1px;'
        )));

        $form->setMethod('post');
        $form->setUseContainer(true);
        $form->setId('login_form');
        $form->setName('login_form');
        $form->setAction($this->getUrl('adminhtml/springbot/login'));
        $this->setForm($form);
    }

}