<?php

class Springbot_Main_Block_Adminhtml_Notifications extends Mage_Adminhtml_Block_Template
{
    /**
     * Return any applicable messages related to Springbot for display on the top admin bar
     *
     * @return array|bool
     */
    public function getMessage()
    {
        try {
            if (Mage::getStoreConfig('springbot/main/show_notifications') == 1) {
                if (!Mage::getModel('springbot_main/store')->isRegistered()) {
                    $message = 'Springbot has been installed successfully. '
                        . '<a href="' . $this->getUrl('adminhtml/springbot/index') . '">Click here to login</a>. '
                        . 'You can turn off Springbot notifications in '
                        . '<a href="' . $this->getUrl('adminhtml/system_config/edit/section/springbot') . '">Springbot configuration.</a>';
                    return array('message' => $message, 'type' => 'success');
                }
            }
        } catch (Exception $e) {
            Mage::log($e->getMessage(), Zend_Log::ERR, 'sb.log');
        }
        return false;
    }

}
