<?php

class Springbot_Main_Block_Async extends Mage_Core_Block_Template
{

    /**
     * Return the domain that the plugin should load the async javascript snippet from
     * @return string
     */
    public function getAssetsDomain()
    {
        return Mage::getStoreConfig('springbot/main/assets_domain');
    }

    /**
     * Return the GUID associated to the current store if it exists. The async snippet expects the GUID to be in
     * lowercase form with dashes removed.
     *
     * @return string|null
     */
    public function getGuid()
    {
        $storeId = Mage::app()->getStore()->getStoreId();
        $guid = Mage::getStoreConfig("springbot/main/store_guid_{$storeId}");
        $guid = str_replace('-', '', $guid);
        return strtolower($guid);
    }

}