<?php

class Springbot_Main_Helper_Attributes extends Mage_Core_Helper_Abstract
{

    /**
     * @param $attributeSet
     *
     * @return mixed
     */
    public function getAttributesBySet($attributeSet)
    {
        if (!is_int($attributeSet)) {
            $attributeSet = $this->_resolveSet($attributeSet);
        }

        return Mage::getResourceModel('eav/entity_attribute_collection')
                   ->setAttributeSetFilter($attributeSet)
                   ->addSetInfo();
    }

    /**
     * @param $attribute
     * @param $value
     *
     * @return mixed
     */
    public function getOptionText($attribute, $value)
    {
        foreach ($this->getOptionsByAttribute($attribute) as $option) {
            if (isset($option['value']) && $option['value'] == $value) {
                return $option['label'];
            }
        }
    }

    /**
     * @param $attribute
     *
     * @return mixed
     */
    private function getOptionsByAttribute($attribute)
    {
        try {
            if ($attribute->usesSource()) {
                return Mage::getResourceModel('eav/entity_attribute_option_collection')
                           ->setAttributeFilter($attribute->getId())
                           ->setStoreFilter(0, false)
                           ->toOptionArray();
            }
        } catch (Exception $e) {
            Mage::log($e->getMessage(), Zend_Log::ERR, 'sb.log');
        }
    }

    /**
     * @param $attributeSet
     *
     * @return mixed
     */
    private function _resolveSet($attributeSet)
    {
        if ($attributeSet instanceof Mage_Eav_Model_Entity_Attribute_Set) {
            $attributeSet = $attributeSet->getAttributeSetId();
        }

        return $attributeSet;
    }

}