<?php

class Springbot_Main_Helper_Data extends Mage_Core_Helper_Abstract
{

    /**
     * @param array $data
     * @param array|string $keys
     * @param mixed $default
     * @param bool $throwException
     * @return mixed
     * @throws Exception
     */
    public function fetch($data, $keys, $default = null, $throwException = false)
    {
        if (!is_array($keys)) {
            $keys = array($keys);
        }
        $key = array_shift($keys);
        if (is_null($data)) {
            return null;
        }
        if (isset($data[$key])) {
            if ($keys) {
                return $this->fetch($data[$key], $keys);
            }
            return $data[$key];
        }
        if ($throwException) {
            throw new Exception("Missing required value for key {$key}", 422);
        }
        else {
            return $default;
        }
    }

}