<?php

class Springbot_Main_Model_Api extends Mage_Core_Model_Abstract
{

    protected $client;
    private $headers = array();

    /**
     * @param array $headers
     * @return $this
     */
    public function setHeaders(array $headers)
    {
        $this->headers = $headers;
        return $this;
    }

    /**
     * @param $url
     * @param $body
     * @param array $headers
     * @return mixed
     * @throws Exception
     */
    public function post($url, $body, $headers = array())
    {
        try {
            return $this->getClient()
                ->setUri($url)
                ->setHeaders(array_merge($this->headers, $headers))
                ->setRawData($body)
                ->request();
        } catch (Exception $e) {
            throw new Exception("HTTP POST failed with code: {$e->getMessage()}");
        }
    }

    /**
     * @param $url
     * @param array $headers
     * @return mixed
     * @throws Exception
     */
    public function get($url, $headers = array())
    {
        try {
            return $this->getClient(Zend_Http_Client::GET)
                ->setUri($url)
                ->setHeaders(array_merge($this->headers, $headers))
                ->request();
        } catch (\Exception $e) {
            throw new \Exception("HTTP GET failed with code: {$e->getMessage()}");
        }
    }

    /**
     * @param $method
     * @return Zend_Http_Client
     */
    private function getClient($method = Zend_Http_Client::POST)
    {
        $apiToken = Mage::getStoreConfig("springbot/main/api_token");
        $client = new Zend_Http_Client;
        $client->setHeaders(array(
            'X-AUTH-TOKEN' => $apiToken,
            'Content-Type' => 'application/json'
        ));
        $client->setMethod($method);
        $client->setConfig(array('maxredirects' => 0, 'timeout' => 30));
        return $client;
    }

}