<?php

class Springbot_Main_Model_Entity_Category extends Springbot_Main_Model_Entity_AbstractEntity
{
    const path = 'catalog/category';
    const singular = 'category';
    const plural = 'categories';

    /**
     * @param $entity
     * @return array
     */
    public function parse($entity)
    {
        return array(
            "category_id" => $entity->getEntityId(),
            "path"        => $entity->getPath(),
            "level"       => $entity->getLevel(),
            "name"        => $entity->getName(),
            "url_path"    => $entity->getUrlPath(),
            "url"         => $entity->getUrl(),
            "is_active"   => $entity->getIsActive(),
            "description" => $entity->getDescription()
        );
    }
    /**
     * @param int $storeId
     * @param $collection
     * @return array
     */
    protected function parseCollection($storeId, $collection)
    {
        $ret = array();
        foreach ($collection as $entity) {
            if ($storeId) {
                $entity->setStoreId($storeId);
            }
            $entity->load($entity->getEntityId());
            $ret[] = $this->parse($entity);
        }
        return $ret;
    }

    /**
     * @param $collection
     * @param int $storeId
     * @return mixed
     */
    protected function filterCollectionByStore($collection, $storeId)
    {
         if (Mage::getStoreConfig('springbot/main/root_category_filter') == true) {
            $rootCategoryId = Mage::getModel('core/store')->load($storeId)->getRootCategoryId();
            $rootPath = Mage::getModel('catalog/category')
            ->setStoreId($storeId)
            ->load($rootCategoryId)
            ->getPath();
            $out = $collection->addAttributeToFilter('path',
                array("eq" => $rootPath),
                array("like" => "{$rootPath}/%")
            );
        } else {
            $out = $collection;
        }
        return $out;
    }

}