<?php

class Springbot_Main_Model_Entity_Guest extends Springbot_Main_Model_Entity_AbstractEntity
{
    const path = 'sales/order';
    const singular = 'guest';
    const plural = 'guests';

    /**
     * @param int $storeId
     * @param null|int $page
     * @return mixed
     */
    public function getFilteredCollection($storeId, $page = null)
    {
        return parent::getFilteredCollection($storeId, $page)
            ->addFieldToFilter('customer_is_guest', true);
    }

    /**
     * @param $entity
     * @return array
     */
    public function parse($entity)
    {
        return array(
            'guest_id'         => $entity->getEntityId() + Mage::getStoreConfig('springbot/main/guest_offset'),
            'order_id'         => $entity->getEntityId(),
            'firstname'        => $entity->getCustomerFirstname(),
            'lastname'         => $entity->getCustomerLastname(),
            'email'            => $entity->getCustomerEmail(),
            'billing_address'  => $this->parseAddress($entity->getBillingAddress()),
            'shipping_address' => $this->parseAddress($entity->getShippingAddress())
        );
    }

    /**
     * @param $collection
     * @param int $storeId
     * @return mixed
     */
    protected function filterCollectionByStore($collection, $storeId)
    {
        return $collection->addFieldToFilter('store_id', $storeId);
    }

}