<?php

class Springbot_Main_Model_Entity_Rule extends Springbot_Main_Model_Entity_AbstractEntity
{
    const path = 'salesrule/rule';
    const singular = 'rule';
    const plural = 'rules';

    /**
     * @param $entity
     * @return array
     */
    public function parse($entity)
    {
        return array(
            'rule_id'                 => $entity->getId(),
            'is_active'               => $entity->getIsActive(),
            'name'                    => $entity->getName(),
            'description'             => $entity->getDescription(),
            'conditions'              => $entity->getConditionsSerialized(),
            'actions'                 => $entity->getConditionsSerialized(),
            'from_date'               => $entity->getFromDate(),
            'to_date'                 => $entity->getToDate(),
            'uses_per_coupon'         => $entity->getUsesPerCoupon(),
            'uses_per_customer'       => $entity->getUsesPerCustomer(),
            'stop_rules_processing'   => $entity->getStopRulesProcessing(),
            'is_advanced'             => $entity->getIsAdvanced(),
            'product_ids'             => $entity->getProductIds(),
            'sort_order'              => $entity->getSortOrder(),
            'simple_action'           => $entity->getSimpleAction(),
            'discount_amount'         => $entity->getDiscountAmount(),
            'discount_qty'            => $entity->getDiscountQty(),
            'discount_step'           => $entity->getDiscountStep(),
            'is_simple_free_shipping' => $entity->getIsSimpleFreeShipping(),
            'applies_to_shipping'     => $entity->getAppliesToShipping(),
            'times_used'              => $entity->getTimesUsed(),
            'is_rss'                  => $entity->getIsRss(),
            'website_ids'             => $entity->getWebsiteIds(),
            'customer_group_ids'      => $entity->getCustomerGroupIds(),
            'coupon_codes'            => $this->getCouponCodes($entity)
        );
    }

    /**
     * @param $collection
     * @param int $storeId
     * @return mixed
     */
    protected function filterCollectionByStore($collection, $storeId)
    {
        return $collection;
    }

    /**
     * @param $rule
     * @return array
     */
    private function getCouponCodes($rule)
    {
        $ret = array();
        $coupons = Mage::getModel('salesrule/coupon')->getCollection()
            ->addFieldToFilter('rule_id', $rule->getId());
        foreach ($coupons as $coupon) {
            $ret[] = $coupon->getCode();
        }
        return $ret;
    }

}