<?php

class Springbot_Main_Model_Entity_Store extends Springbot_Main_Model_Entity_AbstractEntity
{
    const path = 'core/store';
    const singular = 'store';
    const plural = 'stores';

    /**
     * @param $entity
     * @return array
     */
    public function parse($entity)
    {
        return array(
            "store_id"           => $entity->getStoreId(),
            "website_id"         => $entity->getWebsiteId(),
            "name"               => $entity->getName(),
            "code"               => $entity->getCode(),
            "url"                => $entity->getBaseUrl(Mage_Core_Model_Store::URL_TYPE_LINK),
            "is_active"          => $entity->getIsActive(),
            "springbot_guid"     => Mage::getStoreConfig("springbot/main/store_guid_{$entity->getId()}"),
            "springbot_store_id" => Mage::getStoreConfig("springbot/main/store_id_{$entity->getId()}"),
        );
    }

    protected function filterCollectionByStore($collection, $storeId)
    {
        return $collection;
    }

}