<?php

class Springbot_Main_Model_Entity_Subscriber extends Springbot_Main_Model_Entity_AbstractEntity
{
    const path = 'newsletter/subscriber';
    const singular = 'subscriber';
    const plural = 'subscribers';
    const subscriber_offset = 200000000;

    /**
     * @param $entity
     * @return array
     */
    public function parse($entity)
    {
        return array(
            'subscriber_id' => $entity->getId() + self::subscriber_offset,
            'email'         => $entity->getEmail(),
            'optin_status'  => $entity->getSubscriberStatus()
        );
    }

    /**
     * @param $collection
     * @param int $storeId
     * @return mixed
     */
    protected function filterCollectionByStore($collection, $storeId)
    {
        return $collection->addFieldToFilter('store_id', $storeId);
    }

}