<?php

class Springbot_Main_Model_Redirect_Quote extends Mage_Core_Model_Abstract
{

    protected function _construct()
    {
        $this->_init('springbot_main/redirect_quote');
    }

    /**
     * @param int $quoteId
     * @param string $redirectId
     * @return Springbot_Main_Redirect_Quote|null
     */
    public function create($quoteId, $redirectId)
    {
        try {
            $redirect = Mage::getModel('springbot_main/redirect_quote')->setData(array(
                'quote_id'    => $quoteId,
                'redirect_id' => $redirectId,
                'created_at'  => time()
            ));
            if ($redirect->save()) {
                return $redirect;
            }
        }
        catch (Exception $e) {
            Mage::log("Failed to create redirect_quote, {$e->getMessage()}", Zend_Log::DEBUG, 'sb.log');
        }
        return null;
    }


}