<?php

class Springbot_Main_Model_Trackable_Order extends Mage_Core_Model_Abstract
{

    protected function _construct()
    {
        $this->_init('springbot_main/trackable_order');
    }

    /**
     * @param int $orderId
     * @param string $key
     * @param string $value
     * @return null
     */
    public function create($orderId, $key, $value)
    {
        $trackable = Mage::getModel('springbot_main/trackable_order')->setData(array(
            'order_id'   => $orderId,
            'keyname'        => $key,
            'value'      => $value,
            'created_at' => time()
        ));
        try {
            if ($trackable->save()) {
                return $trackable;
            }
        }
        catch (Exception $e) {
            Mage::log("Order trackable constraint failed: {$e->getMessage()}", Zend_Log::DEBUG, 'sb.log');
        }
        return null;
    }

    /**
     * @param int $orderId
     * @param string $key
     * @param mixed $default
     * @return null
     */
    public function get($orderId, $key, $default = null)
    {
        $result = Mage::getModel('springbot_main/trackable_order')->getCollection()
            ->addFieldToFilter('order_id', $orderId)
            ->addFieldToFilter('keyname', $key)
            ->getFirstItem();
        if (!$result->getId()) {
            return $default;
        }
        return $result->getData('value');
    }

}
