<?php

class Springbot_Main_Model_Trackable_Quote extends Mage_Core_Model_Abstract
{

    protected function _construct()
    {
        $this->_init('springbot_main/trackable_quote');
    }

    /**
     * @param int $quoteId
     * @param string $key
     * @param string $value
     * @return null
     */
    public function create($quoteId, $key, $value)
    {
        $trackable = Mage::getModel('springbot_main/trackable_quote')->setData(array(
            'quote_id'   => $quoteId,
            'keyname'        => $key,
            'value'      => $value,
            'created_at' => time()
        ));
        try {
            if ($trackable->save()) {
                return $trackable;
            }
        }
        catch (Exception $e) {
            Mage::log("Quote trackable constraint failed: {$e->getMessage()}", Zend_Log::DEBUG, 'sb.log');
        }
        return null;
    }

    /**
     * @param int $quoteId
     * @param string $key
     * @param mixed $default
     * @return null
     */
    public function get($quoteId, $key, $default = null)
    {
        $result = Mage::getModel('springbot_main/trackable_quote')->getCollection()
            ->addFieldToFilter('quote_id', $quoteId)
            ->addFieldToFilter('keyname', $key)
            ->getFirstItem();


        if (!$result->getId()) {
            return $default;
        }
        return $result->getData('value');
    }

}
