<?php

class Springbot_Main_Observer_Entity_Cart extends Springbot_Main_Observer_AbstractObserver
{

    const endpoint = 'carts';

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onFrontendQuoteSaveAfter($observer)
    {
        if ($quote = $observer->getQuote()) {
            $storeIds = array($quote->getStoreId());
            $this->queue->enqueue(self::webhook_class, 'update', array(self::endpoint, $quote->getId(), $storeIds));
            $this->createTrackables($quote->getId());
        }
    }

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onFrontendCartUpdate($observer)
    {
        if ($cart = $observer->getEvent()->getCart()) {
            if (($quote = $cart->getQuote()) && ($quote instanceof Mage_Sales_Model_Quote)) {
                $storeIds = array($quote->getStoreId());
                $this->queue->enqueue(self::webhook_class, 'update', array(self::endpoint, $quote->getId(), $storeIds));
            }
        }
    }

    /**
     * @param $quoteId
     */
    private function createTrackables($quoteId)
    {
        $userAgent = Mage::helper('core/http')->getHttpUserAgent();
        return Mage::getModel('springbot_main/trackable_quote')->create($quoteId, 'user_agent', $userAgent);
    }

}