<?php

class Springbot_Main_Observer_Entity_Category extends Springbot_Main_Observer_AbstractObserver
{

    const endpoint = 'categories';

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onCategorySaveAfter(Varien_Event_Observer $observer)
    {
        if ($category = $observer->getCategory()) {
            $storeIds = $category->getStoreIds();
            $this->queue->enqueue(self::webhook_class, 'update', array(self::endpoint, $category->getId(), $storeIds));
        }
    }

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onCategoryDeleteAfter(Varien_Event_Observer $observer)
    {
        if ($category = $observer->getCategory()) {
            $storeIds = $category->getStoreIds();
            $this->queue->enqueue(self::webhook_class, 'delete', array(self::endpoint, $category->getId(), $storeIds));
        }
    }

}