<?php

class Springbot_Main_Observer_Entity_Customer extends Springbot_Main_Observer_AbstractObserver
{

    const endpoint = 'customers';

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onCustomerSaveAfter(Varien_Event_Observer $observer)
    {
        if ($customer = $observer->getEvent()->getCustomer()) {
            $storeIds = array($customer->getStoreId());
            $this->queue->enqueue(self::webhook_class, 'update', array(self::endpoint, $customer->getId(), $storeIds));
        }
    }

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onCustomerDeleteBefore(Varien_Event_Observer $observer)
    {
        if ($customer = $observer->getEvent()->getCustomer()) {
            $storeIds = array($customer->getStoreId());
            $this->queue->enqueue(self::webhook_class, 'delete', array(self::endpoint, $customer->getId(), $storeIds));
        }
    }

}