<?php

class Springbot_Main_Observer_Entity_Product extends Springbot_Main_Observer_AbstractObserver
{

    const endpoint = 'products';

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onProductSaveAfter($observer)
    {
        if ($product = $observer->getProduct()) {
            $storeIds = $product->getStoreIds();
            $this->queue->enqueue(self::webhook_class, 'update', array(self::endpoint, $product->getId(), $storeIds));
            Mage::log('ProductSaveAfter ' . $observer->getProduct()->getId() . ' ' . get_class($observer), null, 'sb.log');
        }
    }

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onMassProductSaveAfter($observer)
    {
        Mage::log('MassProductSaveAfter ' . $product . ' ' . get_class($observer), null, 'sb.log');
        if ($products = $observer->getEvent()->getProductIds()) {
            $storeIds = $observer->getEvent()->getStoreIds();
            foreach ($products as $product) {
                $this->queue->enqueue(self::webhook_class, 'update', array(self::endpoint, $product, $storeIds));
                Mage::log('MassProductSaveAfter ' . $product . ' ' . get_class($observer), null, 'sb.log');
            }
        }
    }

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onProductDeleteBefore($observer)
    {
        if ($product = $observer->getProduct()) {
            $storeIds = $product->getStoreIds();
            $this->queue->enqueue(self::webhook_class, 'delete', array(self::endpoint, $product->getId(), $storeIds));
            Mage::log('ProductSaveAfter ' . $observer->getProduct()->getId(), null, 'sb.log');
        }
    }

}