<?php

class Springbot_Main_Observer_Entity_Rule extends Springbot_Main_Observer_AbstractObserver
{

    const endpoint = 'rules';

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onSalesruleRuleSaveAfter($observer)
    {
        if ($rule = $observer->getEvent()->getRule()) {
            $storeIds = $this->getWebsiteIds($rule);
            $this->queue->enqueue(self::webhook_class, 'update', array(self::endpoint, $rule->getId(), $storeIds));
        }
    }

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onSalesruleRuleDeleteBefore($observer)
    {
        if ($rule = $observer->getEvent()->getRule()) {
            $storeIds = $this->getWebsiteIds($rule);
            $this->queue->enqueue(self::webhook_class, 'delete', array(self::endpoint, $rule->getId(), $storeIds));
        }
    }

    /**
     * @param $rule
     * @return array
     */
    private function getWebsiteIds($rule)
    {
        $ids = $rule->getWebsiteIds();
        if (is_string($ids)) {
            $ids = explode(',', $ids);
        }
        if (!is_array($ids)) {
            $ids = array();
        }
        return $ids;
    }

}