<?php

class Springbot_Main_Observer_Entity_Subscriber extends Springbot_Main_Observer_AbstractObserver
{
    const endpoint = 'subscribers';

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onSubscriberSaveAfter($observer)
    {
        if ($subscriber = $observer->getEvent()->getSubscriber()) {
            $storeIds = array($subscriber->getStoreId());
            $this->queue->enqueue(self::webhook_class, 'update', array(self::endpoint, $subscriber->getId(), $storeIds));
        }
    }

    /**
     * @param Varien_Event_Observer $observer
     */
    public function onSubscriberDeleteBefore($observer)
    {
        if ($subscriber = $observer->getEvent()->getSubscriber()) {
            $storeIds = array($subscriber->getStoreId());
            $this->queue->enqueue(self::webhook_class, 'delete', array(self::endpoint, $subscriber->getId(), $storeIds));
        }
    }

}