<?php

class Springbot_Main_Observer_Reconstitution
{

    /**
     * @param Varien_Event_Observer $observer
     */
    public function reconstituteCart($observer)
    {
        try {
            if ($quoteId = Mage::app()->getRequest()->getParam('quote_id')) {
                $suppliedSecurityHash = Mage::app()->getRequest()->getParam('sec_key');
                $this->setQuote($quoteId, $suppliedSecurityHash);
            }
        } catch (Exception $e) {
            Mage::log($e->getMessage(), Zend_Log::ERR, 'sb.log');
        }
    }

    /**
     * @param int $quoteId
     * @param string $suppliedSecurityHash
     * @throws Exception
     */
    private function setQuote($quoteId, $suppliedSecurityHash)
    {
        if (Mage::getStoreConfig('springbot/main/restore_carts') == 1) {
            if ($quote = Mage::getModel('sales/quote')->load($quoteId)) {
                $cartCount = Mage::helper('checkout/cart')->getSummaryCount();
                if ($cartCount == 0) {
                    $quote->setIsActive(true)->save();
                    $token = Mage::getStoreConfig('springbot/main/api_token');
                    $correctSecurityHash = sha1($quoteId . $token);
                    if ($suppliedSecurityHash != $correctSecurityHash) {
                        throw new Exception('Invalid security token when attempting to reconstitute cart');
                    }
                    if (Mage::getStoreConfig('springbot/main/retain_coupon') == 0) {
                        $quote->setCouponCode('');
                        $quote->save();
                    }
                    Mage::getSingleton('checkout/session')->setQuoteId($quoteId);
                }
            }
        }
    }

}

