<?php

class Springbot_Main_Adminhtml_SpringbotController extends Mage_Adminhtml_Controller_Action
{

    /**
     * Display the form for a user to enter their credentials to authenticate their stores
     */
    public function indexAction()
    {

        if (Mage::getModel('springbot_main/store')->isRegistered()) {
            return $this->_redirect('*/*/syncing');
        }
        $this->loadLayout();
        $this->_setActiveMenu('springbot_main');
        $this->renderLayout();
    }

    /**
     * Show the page to indicate to the store owner that their instance is authenticated and syncing
     */
    public function syncingAction()
    {
        if (!Mage::getModel('springbot_main/store')->isRegistered()) {
            return $this->_redirect('*/*/index');
        }
        $this->loadLayout();
        $this->_setActiveMenu('springbot_main');
        $this->renderLayout();
    }

    /**
     * Handle the login form POST when a user submits the form with their credentials
     */
    public function loginAction()
    {
        try {
            $model = Mage::getModel('springbot_main/store');
            $email = $this->getRequest()->getParam('email');
            $password = $this->getRequest()->getParam('password');
            $model->registerStores($email, $password);
        } catch (Exception $e) {
            Mage::getSingleton('adminhtml/session')
                ->addError(Mage::helper('adminhtml')->__($e->getMessage()));
        }
        $this->_redirect('*/*/index');
    }

    /**
     * Determine if the currently logged in user is allowed to view this page
     *
     * @return mixed
     */
    protected function _isAllowed()
    {
        return Mage::getSingleton('admin/session')->isAllowed('springbot_main/sync');
    }
}
