<?php

class Springbot_Main_CacheController extends Mage_Core_Controller_Front_Action
{
    private $cache;

    public function _construct()
    {
        $this->cache =  Mage::app()->getCacheInstance();
    }

    public function viewCacheTypesAction()
    {
        $this->getResponse()->setBody(json_encode(array_keys($this->cache->getTypes())));
    }

    public function viewCacheStatusAction()
    {
        $cacheStatusArray = array();
        foreach ($this->cache->getTypes() as $type) {
            $cacheStatusArray[] = array(
                'type'   => $type->getId(),
                'status' => $type->getStatus()
            );
        }
        $this->getResponse()->setBody(json_encode($cacheStatusArray));
    }

    public function cleanCacheAction()
    {
        $this->getResponse()->setBody(json_encode(array(
            'successful' => $this->cache->clean()
        )));
    }

}