<?php

class Springbot_Main_CreateCartController extends Mage_Core_Controller_Front_Action
{
    /**
     * Get or Create a cart for the current user.
     */
    public function getCartAction()
    {
        try {
            $quote = Mage::getSingleton('checkout/session')->getQuote();
            if (!$quote->hasEntityId()) {
                $quote->save();
                Mage::getSingleton('checkout/session')->setQuoteId($quote->getId());
            }
        }
        catch (Exception $e) {
            $msg = "Failed to generate new cart: {$e->getMessage()}";
            Mage::log($msg, Zend_Log::ERR, 'sb.log');
        }
        $this->getResponse()->setHeader('Content-type', 'application/json');
        if (!isset($msg)) {
            $out = array("cart_id" => $quote->getId());
            $this->getResponse()->setBody(json_encode($out));
        } else {
            $out = array("error" => $msg);
            $this->getResponse()->setBody(json_encode($out));
        }
    }

}