<?php

class Springbot_Main_EntitiesController extends Mage_Core_Controller_Front_Action
{

    protected $storeId;

    public function _construct()
    {
        $this->storeId = $this->getRequest()->getParam('store_id');
    }

    /**
     * Attribute Sets
     */
    public function viewAttributeSetAction()
    {
        $this->getOne('springbot_main/entity_attributeSet');
    }

    public function viewAttributeSetsAction()
    {
        $this->getMultiple('springbot_main/entity_attributeSet');
    }

    public function viewAttributeSetCountAction()
    {
        $this->getCount('springbot_main/entity_attributeSet');
    }

    /**
     * Carts
     */
    public function viewCartAction()
    {
        $this->getOne('springbot_main/entity_cart');
    }

    public function viewCartsAction()
    {
        $this->getMultiple('springbot_main/entity_cart');
    }

    public function viewCartCountAction()
    {
        $this->getCount('springbot_main/entity_cart');
    }

    /**
     * Categories
     */
    public function viewCategoriesAction()
    {
        $this->getMultiple('springbot_main/entity_category');
    }

    public function viewCategoryAction()
    {
        $this->getOne('springbot_main/entity_category');
    }

    public function viewCategoryCountAction()
    {
        $this->getCount('springbot_main/entity_category');
    }

    /**
     * Customers
     */
    public function viewCustomersAction()
    {
        $this->getMultiple('springbot_main/entity_customer');
    }

    public function viewCustomerAction()
    {
        $this->getOne('springbot_main/entity_customer');
    }

    public function viewCustomerCountAction()
    {
        $this->getCount('springbot_main/entity_customer');
    }

    /**
     * Guests
     */
    public function viewGuestAction()
    {
        $this->getOne('springbot_main/entity_guest');
    }

    public function viewGuestsAction()
    {
        $this->getMultiple('springbot_main/entity_guest');
    }

    public function viewGuestCountAction()
    {
        $this->getCount('springbot_main/entity_guest');
    }

    /**
     * Inventory
     */
    public function viewInventoryAction()
    {
        $this->getOne('springbot_main/entity_inventory');
    }

    public function viewInventoriesAction()
    {
        $this->getMultiple('springbot_main/entity_inventory');
    }

    public function viewInventoryCountAction()
    {
        $this->getCount('springbot_main/entity_inventory');
    }

    /**
     * Orders
     */
    public function createOrderAction()
    {
        $this->createOne('springbot_main/entity_order');
    }

    public function viewOrderAction()
    {
        $this->getOne('springbot_main/entity_order');
    }

    public function viewOrdersAction()
    {
        $this->getMultiple('springbot_main/entity_order');
    }

    public function viewOrderCountAction()
    {
        $this->getCount('springbot_main/entity_order');
    }

    /**
     * Products
     */
    public function viewProductAction()
    {
        $this->getOne('springbot_main/entity_product');
    }

    public function viewProductsAction()
    {
        $this->getMultiple('springbot_main/entity_product');
    }

    public function viewProductCountAction()
    {
        $this->getCount('springbot_main/entity_product');
    }

    /**
     * Rules
     */
    public function viewRuleAction()
    {
        $this->getOne('springbot_main/entity_rule');
    }

    public function viewRulesAction()
    {
        $this->getMultiple('springbot_main/entity_rule');
    }

    public function viewRuleCountAction()
    {
        $this->getCount('springbot_main/entity_rule');
    }

    /**
     * Stores
     */
    public function viewStoresAction()
    {
        $this->getMultiple('springbot_main/entity_store');
    }

    public function viewStoreAction()
    {
        $this->getOne('springbot_main/entity_store');
    }

    /**
     * Subscribers
     */
    public function viewSubscriberAction()
    {
        $this->getOne('springbot_main/entity_subscriber');
    }

    public function viewSubscribersAction()
    {
        $this->getMultiple('springbot_main/entity_subscriber');
    }

    public function viewSubscriberCountAction()
    {
        $this->getCount('springbot_main/entity_subscriber');
    }

    /**
     * @param string $path
     * @return mixed
     */
    private function getModel($path)
    {
        $model = Mage::getModel($path, array('store_id' => $this->storeId));
        return $model;
    }

    /**
     * @param string $path
     * @throws Exception
     */
    private function createOne($path)
    {
        $model = $this->getModel($path);
        $body = json_decode($this->getRequest()->getRawBody(), true);
        if ($body === null) {
            throw new Exception('Invalid JSON', 422);
        }
        $this->getResponse()->setBody(json_encode($model->create($this->storeId, $body)));
    }

    /**
     * @param string $path
     */
    private function getOne($path)
    {
        $model = $this->getModel($path);
        $id = $this->getRequest()->getParam('entity_id');
        if ($path === 'springbot_main/entity_store') {
            $id = $this->getRequest()->getParam('store_id');
        }
        $this->getResponse()->setBody(json_encode($model->one($this->storeId, $id)));
    }

    /**
     * @param $path
     */
    private function getMultiple($path)
    {
        $model = $this->getModel($path);
        $page = $this->getRequest()->getParam('page');
        $this->getResponse()->setBody(json_encode($model->multiple($this->storeId, $page)));
    }

    /**
     * @param $path
     */
    private function getCount($path)
    {
        $model = $this->getModel($path);
        $this->getResponse()->setBody(json_encode(array('count' => $model->getCount($this->storeId))));
    }

}