<?php

class Springbot_Main_IndexController extends Mage_Core_Controller_Front_Action
{

    /**
     * @return $this
     */
    public function preDispatch()
    {
        $this->setFlag('', self::FLAG_NO_PRE_DISPATCH, 1);
        $this->setFlag('', self::FLAG_NO_POST_DISPATCH, 1);
        parent::preDispatch();
        return $this;
    }

    /**
     * Associate a user's email to their quote for abandoned carts. We use springbot_update to maintain backward
     * compatibility with our existing javascript listeners.
     */
    public function indexAction()
    {
        try {
            $params = $this->getRequest()->getParams();
            if (isset($params['email'])) {
                $email = Mage::getModel('springbot_main/email');
                $email->associateEmailToQuote($params['email']);
            }
        }
        catch (Exception $e) {
            Mage::log("Failed to associate email to quote: {$e->getMessage()}", Zend_Log::ERR, 'sb.log');
        }
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody('{}');
    }


}