<?php

class Springbot_Main_ModulesController extends Mage_Core_Controller_Front_Action
{

    /**
     * Responds with a list of installed modules.
     */
    public function viewModulesAction()
    {
        $modules = Mage::getConfig()->getNode('modules')->children();
        $modulesArray = array();
        foreach ($modules as $moduleName => $moduleSettings) {
            $modulesArray[] = array(
                'name'          => $moduleName,
                'active'        => ($moduleSettings->is('active') ? true : false),
                'setup_version' => reset($moduleSettings->version),
                'sequence'      => array()
            );
        }

        $this->getResponse()->setBody(json_encode(array('modules' => $modulesArray)));
    }

}