<?php

$installer = $this;
/* @var $installer Springbot_Queue_Model_Resource_Setup */

$connection = $installer->getConnection();

$installer->startSetup();

// Quote trackables table
// Check if tables exist
if (!$installer->tableExists('springbot_main/trackable_quote')) {
    $table = $connection->newTable($installer->getTable('springbot_main/trackable_quote'))
        ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
            'identity' => true,
            'unsigned' => true,
            'nullable' => false,
            'primary'  => true,
        ), 'ID')
        ->addColumn('quote_id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array('nullable' => false), 'Quote ID')
        ->addColumn('key', Varien_Db_Ddl_Table::TYPE_TEXT, 16, array('nullable' => false), 'Key')
        ->addColumn('value', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => false), 'Value')
        ->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array('nullable' => false), 'Created At');
    $connection->createTable($table);

    $connection->addIndex(
        $installer->getTable('springbot_main/trackable_quote'),
        $installer->getIdxName(
            'springbot_main/trackable_quote',
            array('quote_id', 'key'), Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
        ),
        array('quote_id', 'key'),
        Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
    );
}

// Order trackables table
// Check if tables exist
if (!$installer->tableExists('springbot_main/trackable_order')) {
    $table = $connection->newTable($installer->getTable('springbot_main/trackable_order'))
        ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
            'identity' => true,
            'unsigned' => true,
            'nullable' => false,
            'primary'  => true,
        ), 'ID')
        ->addColumn('order_id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array('nullable' => false), 'Order ID')
        ->addColumn('key', Varien_Db_Ddl_Table::TYPE_TEXT, 16, array('nullable' => false), 'Key')
        ->addColumn('value', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => false), 'Value')
        ->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array('nullable' => false), 'Created At');
    $connection->createTable($table);

    $connection->addIndex(
        $installer->getTable('springbot_main/trackable_order'),
        $installer->getIdxName(
            'springbot_main/trackable_order',
            array('order_id', 'key'), Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
        ),
        array('order_id', 'key'),
        Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
    );
}

// Order redirect table
// Check if tables exist
if (!$installer->tableExists('springbot_main/redirect_quote')) {
    $table = $connection->newTable($installer->getTable('springbot_main/redirect_quote'))
        ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
            'identity' => true,
            'unsigned' => true,
            'nullable' => false,
            'primary'  => true,
        ), 'ID')
        ->addColumn('quote_id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array('nullable' => false), 'Quote ID')
        ->addColumn('order_id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array('nullable' => false), 'Order ID')
        ->addColumn('redirect_id', Varien_Db_Ddl_Table::TYPE_TEXT, 24, array('nullable' => false), 'Redirect ID')
        ->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array('nullable' => false), 'Created At');
    $connection->createTable($table);

    $connection->addIndex(
        $installer->getTable('springbot_main/redirect_quote'),
        $installer->getIdxName(
            'springbot_main/redirect_quote',
            array('quote_id', 'redirect_id'), Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
        ),
        array('quote_id', 'redirect_id'),
        Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
    );
}

// Marketplace orders table
// Check if tables exist
if (!$installer->tableExists('springbot_main/marketplace_order')) {
    $table = $connection->newTable($installer->getTable('springbot_main/marketplace_order'))
        ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
            'identity' => true,
            'unsigned' => true,
            'nullable' => false,
            'primary'  => true,
        ), 'ID')
        ->addColumn('order_id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array('nullable' => false), 'Order ID')
        ->addColumn('increment_id', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => false), 'Increment ID')
        ->addColumn('remote_order_id', Varien_Db_Ddl_Table::TYPE_TEXT, 24, array('nullable' => false), 'Remote Order ID')
        ->addColumn('marketplace_type', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => false), 'Type')
        ->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array('nullable' => false), 'Created At');
    $connection->createTable($table);

    $connection->addIndex(
        $installer->getTable('springbot_main/marketplace_order'),
        $installer->getIdxName(
            'springbot_main/marketplace_order',
            array('remote_order_id'), Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
        ),
        array('remote_order_id'),
        Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
    );
}
$installer->endSetup();



// Check if tables exist from previous version and run migrations if necessary
if ($installer->tableExists('springbot_trackable')) {
    Mage::getModel('springbot_queue/manager')->enqueue('Springbot_Main_Model_Migrate', 'migrateTrackables');
}

if ($installer->tableExists('springbot_redirect')) {
    Mage::getModel('springbot_queue/manager')->enqueue('Springbot_Main_Model_Migrate', 'migrateRedirects');
}

// Generate the access_token for the first time
$auth = Mage::getModel('springbot_router/auth');
$auth->getAccessToken();
