<?php

$installer = $this;
/* @var $installer Springbot_Queue_Model_Resource_Setup */
$connection = $installer->getConnection();
$installer->startSetup();

// Jobs table

if (!$installer->tableExists('springbot_queue/job')) {
    $table = $installer->getConnection()->newTable($installer->getTable('springbot_queue/job'))
        ->addColumn('id', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
            'identity' => true,
            'unsigned' => true,
            'nullable' => false,
            'primary'  => true,
        ), 'ID')
        ->addColumn('method', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => false,), 'Method')
        ->addColumn('args', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => false,), 'Arguments')
        ->addColumn('class', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => false,), 'Class')
        ->addColumn('hash', Varien_Db_Ddl_Table::TYPE_TEXT, 40, array('nullable' => false,), 'Hash')
        ->addColumn('queue', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => false,), 'Queue')
        ->addColumn('priority', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array('nullable' => false,), 'Priority')
        ->addColumn('attempts', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array(
            'nullable' => false,
            'default'  => 0
        ), 'Attempts')
        ->addColumn('run_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array('nullable' => true,), 'Initial Run Time')
        ->addColumn('locked_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array('nullable' => true,), 'Locked At')
        ->addColumn('locked_by', Varien_Db_Ddl_Table::TYPE_INTEGER, null, array('nullable' => true,), 'Locked By')
        ->addColumn('error', Varien_Db_Ddl_Table::TYPE_TEXT, null, array('nullable' => true,), 'Error')
        ->addColumn('next_run_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array('nullable' => true,), 'Next Run At')
        ->addColumn('created_at', Varien_Db_Ddl_Table::TYPE_TIMESTAMP, null, array('nullable' => false,), 'Created At');

    $installer->getConnection()->createTable($table);

    $connection->addIndex(
        $installer->getTable('springbot_queue/job'),
        $installer->getIdxName(
            'springbot_queue/job',
            array('hash'), Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
        ),
        array('hash'),
        Varien_Db_Adapter_Interface::INDEX_TYPE_UNIQUE
    );
}
$installer->endSetup();