#!/bin/bash
SLUG="Springbot-"
IGNORES="./Springbot.xml
$SLUG*
.DS_Store
*.DS_Store
.git
.gitignore
.idea
.phpintel
/.git/*
/.idea/*
/config/*
/scripts/*
/Test/*
/tests/*
/vendor/*
build.sh
CHANGELOG.md
circle.yml
composer.json
composer.lock
LICENSE.md
modman
phpunit.xml
README.md
scripts
springbot-deploy
tags
tests"

function usage {
echo "Usage: $0 [-t] [-z]"
}

function init {
FILENAME=${SLUG}`cat app/code/community/Springbot/Main/etc/config.xml | perl -n -e'/<version>(.*)<\/version>/ && print $1'`
rm ${SLUG}* &> /dev/null
}

function build_zip {
init
zip -r ${FILENAME}".zip" . -x ${ZIPFILE} ${IGNORES}
}

function build_tar {
init

for var in ${IGNORES}
do
  excludes=${excludes}" --exclude=$var"
done

tar -czvf ${FILENAME}".tgz" ${excludes} *
}


[[ $1 ]] || { usage; }

while getopts "tz" arg; do
  case "${arg}" in
    t) build_tar; shift 2 ;;
  z) build_zip; shift 2 ;;
esac
done
